diff --git a/drivers/misc/vmeta.c b/drivers/misc/vmeta.c
new file mode 100644
index 000000000000..13e59b8afe9b
--- /dev/null
+++ b/drivers/misc/vmeta.c
@@ -0,0 +1,1086 @@
+/*
+ * drivers/misc/vmeta.c
+ *
+ * Marvell multi-format video decoder engine driver.
+ *
+ * This file is licensed under the terms of the GNU General Public
+ * License version 2.  This program is licensed "as is" without any
+ * warranty of any kind, whether express or implied.
+ *
+ * Based on an earlier version by Peter Liao.
+ * Taken from Rabeeh's Cubox kernel and cleaned up by Russell King.
+ */
+
+#include <linux/clk.h>
+#include <linux/completion.h>
+#include <linux/dma-buf.h>
+#include <linux/dma-mapping.h>
+#include <linux/file.h>
+#include <linux/idr.h>
+#include <linux/interrupt.h>
+#include <linux/io.h>
+#include <linux/miscdevice.h>
+#include <linux/mman.h>
+#include <linux/module.h>
+#include <linux/mutex.h>
+#include <linux/notifier.h>
+#include <linux/platform_device.h>
+#include <linux/pm_runtime.h>
+#include <linux/poll.h>
+#include <linux/sched.h>
+#include <linux/shmem_fs.h>
+#include <linux/slab.h>
+#include <linux/suspend.h>
+#include <linux/uaccess.h>
+#include <linux/vmeta.h>
+
+#define VDEC_HW_CONTEXT_SIZE	SZ_512K
+#define VDEC_OBJ_SIZE		SZ_64K
+
+#define VMETA_NAME		"ap510-vmeta"
+#define VMETA_REVISION		105
+
+struct vmeta_memory {
+	void		*cpu;
+	dma_addr_t	dma;
+	size_t		size;
+};
+
+/* private */
+struct vmeta_instance {
+	struct device		*dev;
+	struct mutex		mutex;
+	unsigned long		use;
+
+	struct miscdevice	misc;
+
+	phys_addr_t		reg_phys;
+	size_t			reg_size;
+	struct vmeta_memory	memory;
+
+	/* shared s/w context */
+	struct file		*sw_context;
+
+	/* irq */
+	int			irq_bus;
+	int			irq_func;
+	struct timer_list	irq_poll_timer;
+	spinlock_t		irq_lock;
+	unsigned long		irq_flag;
+
+	/* clock / power */
+	struct clk		*clk;
+
+	/* pm */
+	wait_queue_head_t	suspend_wait;
+	struct completion	suspend_complete;
+	bool			suspend;
+	struct notifier_block	suspend_notifier;
+
+	/* id and access arbitration */
+	DECLARE_BITMAP(id_used, MAX_VMETA_INSTANCE);
+	DECLARE_BITMAP(id_registered, MAX_VMETA_INSTANCE);
+	wait_queue_head_t	id_wait;
+	unsigned		id_active;
+	enum _VMETA_LOCK_FLAG	id_lock;
+	int			id_refcnt;
+
+	/* io support */
+	atomic_t		events;
+	wait_queue_head_t	event_wait;
+	struct fasync_struct	*event_queue;
+};
+
+struct vmeta_user {
+	struct vmeta_instance	*vi;
+	unsigned long		events;
+	DECLARE_BITMAP(id, MAX_VMETA_INSTANCE);
+	bool			clock_on;
+	bool			power_on;
+	struct mutex		buf_mutex;
+	struct idr		buf_idr;
+};
+
+struct vmeta_buffer {
+	struct dma_buf		*buf;
+	struct dma_buf_attachment *attach;
+	struct sg_table		*sgt;
+};
+
+static int vmeta_dmabuf_release_one(int id, void *p, void *data)
+{
+	struct vmeta_buffer *vb = p;
+
+	dma_buf_unmap_attachment(vb->attach, vb->sgt, DMA_BIDIRECTIONAL);
+	dma_buf_detach(vb->buf, vb->attach);
+	dma_buf_put(vb->buf);
+	kfree(vb);
+
+	return 0;
+}
+
+static int vmeta_dmabuf_import(struct vmeta_user *vu,
+	struct vmeta_dmabuf_import *import)
+{
+	struct vmeta_buffer *vb;
+	int ret;
+
+	vb = kmalloc(sizeof(*vb), GFP_KERNEL);
+	if (!vb)
+		return -ENOMEM;
+
+	vb->buf = dma_buf_get(import->fd);
+	if (IS_ERR(vb->buf)) {
+		ret = PTR_ERR(vb->buf);
+		goto free;
+	}
+
+	vb->attach = dma_buf_attach(vb->buf, vu->vi->dev);
+	if (IS_ERR(vb->attach)) {
+		ret = PTR_ERR(vb->attach);
+		goto put;
+	}
+
+	vb->sgt = dma_buf_map_attachment(vb->attach, DMA_BIDIRECTIONAL);
+	if (IS_ERR(vb->sgt)) {
+		ret = PTR_ERR(vb->sgt);
+		goto detach;
+	}
+
+	if (vb->sgt->nents != 1) {
+		ret = -EINVAL;
+		goto detach;
+	}
+
+	mutex_lock(&vu->buf_mutex);
+	ret = idr_alloc(&vu->buf_idr, vb, 1, 0, GFP_KERNEL);
+	mutex_unlock(&vu->buf_mutex);
+
+	if (ret < 0)
+		goto unmap;
+
+	import->phys = sg_dma_address(vb->sgt->sgl);
+	import->size = sg_dma_len(vb->sgt->sgl);
+	import->id = ret;
+
+	return 0;
+
+ unmap:
+	dma_buf_unmap_attachment(vb->attach, vb->sgt, DMA_BIDIRECTIONAL);
+ detach:
+	dma_buf_detach(vb->buf, vb->attach);
+ put:
+	dma_buf_put(vb->buf);
+ free:
+	kfree(vb);
+	return ret;
+}
+
+static int vmeta_dmabuf_release(struct vmeta_user *vu, int id)
+{
+	struct vmeta_buffer *vb;
+
+	mutex_lock(&vu->buf_mutex);
+	vb = idr_find(&vu->buf_idr, id);
+	if (vb)
+		idr_remove(&vu->buf_idr, id);
+	mutex_unlock(&vu->buf_mutex);
+	if (!vb)
+		return -EINVAL;
+
+	dma_buf_unmap_attachment(vb->attach, vb->sgt, DMA_BIDIRECTIONAL);
+	dma_buf_detach(vb->buf, vb->attach);
+	dma_buf_put(vb->buf);
+	kfree(vb);
+
+	return 0;
+}
+
+static void vmeta_event(struct vmeta_instance *vi)
+{
+	atomic_inc(&vi->events);
+	wake_up_interruptible(&vi->event_wait);
+	kill_fasync(&vi->event_queue, SIGIO, POLL_IN);
+}
+
+static int vmeta_pm_event(struct notifier_block *notifier, unsigned long val,
+			  void *v)
+{
+	struct vmeta_instance *vi = container_of(notifier, struct vmeta_instance, suspend_notifier);
+	int ret;
+
+	/*
+	 * Hibernation and suspend events
+	 * PM_HIBERNATION_PREPARE 0x0001 Going to hibernate
+	 * PM_POST_HIBERNATION    0x0002 Hibernation finished
+	 * PM_SUSPEND_PREPARE     0x0003 Going to suspend the system
+	 * PM_POST_SUSPEND        0x0004 Suspend finished
+	 * PM_RESTORE_PREPARE     0x0005 Going to restore a saved image
+	 * PM_POST_RESTORE        0x0006 Restore failed
+	 */
+	vmeta_event(vi);
+
+	switch (val) {
+	case PM_SUSPEND_PREPARE:
+	case PM_HIBERNATION_PREPARE:
+		if (vi->use < 1)
+			break;
+
+		vi->suspend = true;
+		ret = wait_for_completion_killable_timeout(&vi->suspend_complete, HZ);
+		if (ret <= 0) {
+			/* Timed out or killed */
+			vi->suspend = false;
+			return NOTIFY_BAD;
+		}
+		break;
+	case PM_POST_SUSPEND:
+	case PM_POST_HIBERNATION:
+		vi->suspend = false;
+		wake_up_interruptible(&vi->suspend_wait);
+		break;
+	}
+
+	return NOTIFY_OK;
+}
+
+static int __vmeta_power_on(struct vmeta_instance *vi)
+{
+	pm_runtime_get_sync(vi->dev);
+
+	return 0;
+}
+
+static int __vmeta_power_off(struct vmeta_instance *vi)
+{
+	pm_runtime_mark_last_busy(vi->dev);
+	pm_runtime_put_autosuspend(vi->dev);
+
+	return 0;
+}
+
+static int __vmeta_clk_on(struct vmeta_instance *vi)
+{
+	clk_prepare_enable(vi->clk);
+
+	return 0;
+}
+
+static int __vmeta_clk_off(struct vmeta_instance *vi)
+{
+	clk_disable_unprepare(vi->clk);
+
+	return 0;
+}
+
+static int vmeta_clk_switch(struct vmeta_instance *vi, unsigned long clk_flag)
+{
+	int ret = 0;
+	unsigned long clk_rate = 0;
+
+	if (IS_ERR(vi->clk)) {
+		dev_err(vi->dev, "vmeta_clk_switch error\n");
+		return -1;
+	}
+
+	mutex_lock(&vi->mutex);
+	if (clk_flag == 0)
+		clk_rate = 400000000; /* 400MHz */
+	else if (clk_flag == 1)
+		clk_rate = 500000000; /* 500MHz */
+	else if (clk_flag == 2)
+		clk_rate = 667000000; /* 667MHz */
+	ret = clk_set_rate(vi->clk, clk_rate);
+	mutex_unlock(&vi->mutex);
+	return ret;
+}
+
+static void vmeta_irq_poll_timer_handler(unsigned long data)
+{
+	struct vmeta_instance *vi = (struct vmeta_instance *)data;
+
+	if (vi->irq_flag == 0)
+		vmeta_event(vi);
+
+	mod_timer(&vi->irq_poll_timer, jiffies + HZ/100); /* 10ms timer */
+}
+
+static irqreturn_t vmeta_bus_irq_handler(int irq, void *dev_id)
+{
+	struct vmeta_instance *vi = dev_id;
+
+	dev_err(vi->dev, "bus error detected\n");
+	vmeta_event(vi);
+	return IRQ_HANDLED;
+}
+
+static irqreturn_t vmeta_func_irq_handler(int irq, void *dev_id)
+{
+	struct vmeta_instance *vi = dev_id;
+	unsigned long flags;
+
+	/*
+	 * Just disable the interrupt in the interrupt controller, and
+	 * remember the state so we can allow user space to enable it later.
+	 */
+	spin_lock_irqsave(&vi->irq_lock, flags);
+	if (!vi->irq_flag) {
+		vi->irq_flag = 1;
+		disable_irq_nosync(irq);
+	}
+	spin_unlock_irqrestore(&vi->irq_lock, flags);
+
+	vmeta_event(vi);
+
+	return IRQ_HANDLED;
+}
+
+static int vmeta_irqcontrol(struct vmeta_instance *vi, s32 irq_on)
+{
+	unsigned long flags;
+
+	/*
+	 * Allow user space to enable and disable the interrupt
+	 * in the interrupt controller, but keep track of the
+	 * state to prevent per-irq depth damage.
+	 *
+	 * Serialize this operation to support multiple tasks.
+	 */
+	spin_lock_irqsave(&vi->irq_lock, flags);
+	if (irq_on) {
+		if (vi->irq_flag) {
+			vi->irq_flag = 0;
+			if (vi->irq_func > 0)
+				enable_irq(vi->irq_func);
+		}
+	} else {
+		if (!vi->irq_flag) {
+			vi->irq_flag = 1;
+			if (vi->irq_func > 0)
+				disable_irq_nosync(vi->irq_func);
+		}
+	}
+	spin_unlock_irqrestore(&vi->irq_lock, flags);
+
+	if (vi->irq_func > 0)
+		synchronize_irq(vi->irq_func);
+
+	return 0;
+}
+
+
+static ssize_t vmeta_write(struct file *file, const char __user *p,
+	size_t sz, loff_t *off)
+{
+	struct vmeta_user *vu = file->private_data;
+	int v;
+
+	if (sz != sizeof(int) || vu->vi->irq_func <= 0)
+		return -EINVAL;
+
+	if (get_user(v, (int __user *)p))
+		return -EFAULT;
+
+	/* Reset IRQ event counter */
+	vu->events = atomic_read(&vu->vi->events);
+
+	return vmeta_irqcontrol(vu->vi, v);
+}
+
+static unsigned vmeta_poll(struct file *file, struct poll_table_struct *pt)
+{
+	struct vmeta_user *vu = file->private_data;
+
+	poll_wait(file, &vu->vi->event_wait, pt);
+	if (vu->events != atomic_read(&vu->vi->events))
+		return POLLIN | POLLRDNORM;
+	return 0;
+}
+
+static int vmeta_mmap(struct file *file, struct vm_area_struct *vma)
+{
+	struct vmeta_user *vu = file->private_data;
+	phys_addr_t phys;
+	size_t size;
+
+	switch (vma->vm_pgoff) {
+	case 0:
+		phys = vu->vi->reg_phys;
+		size = vu->vi->reg_size;
+		break;
+
+	case 1:
+		phys = vu->vi->memory.dma;
+		size = vu->vi->memory.size;
+		break;
+
+	default:
+		return -EINVAL;
+	}
+
+	/* Don't allow mapping a region larger than we have */
+	if (vma->vm_end - vma->vm_start > size)
+		return -EINVAL;
+
+	vma->vm_flags |= VM_IO | VM_DONTEXPAND;
+	vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+
+	return remap_pfn_range(vma, vma->vm_start, phys >> PAGE_SHIFT,
+				vma->vm_end - vma->vm_start,
+				vma->vm_page_prot);
+}
+
+static int vmeta_open(struct inode *inode, struct file *file)
+{
+	struct miscdevice *misc = file->private_data;
+	struct vmeta_instance *vi = container_of(misc, struct vmeta_instance, misc);
+	struct vmeta_user *vu;
+	int ret;
+
+	vu = kmalloc(sizeof(*vu), GFP_KERNEL);
+	if (!vu)
+		return -ENOMEM;
+
+	vu->vi = vi;
+	vu->events = atomic_read(&vi->events);
+	bitmap_zero(vu->id, MAX_VMETA_INSTANCE);
+	mutex_init(&vu->buf_mutex);
+	idr_init(&vu->buf_idr);
+
+	mutex_lock(&vi->mutex);
+	ret = __vmeta_clk_on(vi);
+	if (ret == 0)
+		ret = __vmeta_power_on(vi);
+	if (ret != 0)
+		__vmeta_clk_off(vi);
+	if (ret == 0) {
+		vu->clock_on = true;
+		vu->power_on = true;
+	}
+	mutex_unlock(&vi->mutex);
+
+	file->private_data = vu;
+
+	return 0;
+}
+
+static int vmeta_release(struct inode *inode, struct file *file)
+{
+	struct vmeta_user *vu = file->private_data;
+	struct vmeta_instance *vi = vu->vi;
+	DECLARE_BITMAP(ids, MAX_VMETA_INSTANCE);
+	int id;
+
+	mutex_lock(&vi->mutex);
+	for (id = 0; id < MAX_VMETA_INSTANCE; id++) {
+		if (test_bit(id, vu->id)) {
+			if (vi->id_active == id) {
+				/* in case, current instance have been locked */
+				vi->id_active = MAX_VMETA_INSTANCE;
+				if (vi->id_lock == VMETA_LOCK_ON) {
+					dev_err(vi->dev, "instance id(%d) holds the lock and exit normally\n",
+						id);
+					vi->id_lock = VMETA_LOCK_FORCE_INIT;
+				}
+			}
+		}
+	}
+
+	/* Clear the registered and used bitmaps of IDs used by this process */
+	bitmap_and(ids, vi->id_registered, vu->id, MAX_VMETA_INSTANCE);
+	vi->id_refcnt -= bitmap_weight(ids, MAX_VMETA_INSTANCE);
+	bitmap_andnot(vi->id_registered, vi->id_registered, vu->id, MAX_VMETA_INSTANCE);
+	bitmap_andnot(vi->id_used, vi->id_used, vu->id, MAX_VMETA_INSTANCE);
+
+	wake_up_interruptible(&vi->id_wait);
+
+	if (vu->power_on)
+		__vmeta_power_off(vi);
+	if (vu->clock_on)
+		__vmeta_clk_off(vi);
+
+	mutex_unlock(&vi->mutex);
+
+	idr_for_each(&vu->buf_idr, vmeta_dmabuf_release_one, vu);
+	idr_destroy(&vu->buf_idr);
+
+	kfree(vu);
+
+	return 0;
+}
+
+static int vmeta_fasync(int fd, struct file *file, int on)
+{
+	struct vmeta_user *vu = file->private_data;
+	return fasync_helper(fd, file, on, &vu->vi->event_queue);
+}
+
+
+static int vmeta_get_user_id(struct vmeta_user *vu, unsigned *arg)
+{
+	struct vmeta_instance *vi = vu->vi;
+	int id;
+
+	mutex_lock(&vi->mutex);
+	id = find_first_zero_bit(vi->id_used, MAX_VMETA_INSTANCE);
+	if (id < MAX_VMETA_INSTANCE)
+		__set_bit(id, vi->id_used);
+	mutex_unlock(&vi->mutex);
+
+	__set_bit(id, vu->id);
+	*arg = id;
+
+	return 0;
+}
+
+static int vmeta_free_user_id(struct vmeta_user *vu, unsigned id)
+{
+	struct vmeta_instance *vi = vu->vi;
+	int ret;
+
+	if (id >= MAX_VMETA_INSTANCE)
+		return -EINVAL;
+
+	mutex_lock(&vi->mutex);
+	if (!test_bit(id, vi->id_used)) {
+		ret = -EACCES;
+	} else {
+		if (test_bit(id, vi->id_registered))
+			vi->id_refcnt--;
+		__clear_bit(id, vi->id_registered);
+		__clear_bit(id, vi->id_used);
+		ret = 0;
+	}
+	mutex_unlock(&vi->mutex);
+
+	if (ret == 0)
+		__clear_bit(id, vu->id);
+
+	return ret;
+}
+
+static int vmeta_register_user_id(struct vmeta_user *vu, unsigned id)
+{
+	struct vmeta_instance *vi = vu->vi;
+	int ret;
+
+	if (id >= MAX_VMETA_INSTANCE)
+		return -EINVAL;
+
+	mutex_lock(&vi->mutex);
+	if (!test_bit(id, vi->id_used)) {
+		ret = -EACCES;
+	} else if (test_bit(id, vi->id_registered)) {
+		ret = -EBUSY;
+	} else {
+		__set_bit(id, vi->id_registered);
+		vi->id_refcnt++;
+		ret = 0;
+	}
+	mutex_unlock(&vi->mutex);
+
+	return ret;
+}
+
+static int vmeta_unregister_user_id(struct vmeta_user *vu, unsigned id)
+{
+	struct vmeta_instance *vi = vu->vi;
+	int ret;
+
+	if (id >= MAX_VMETA_INSTANCE)
+		return -EINVAL;
+
+	mutex_lock(&vi->mutex);
+	if (!test_bit(id, vi->id_used)) {
+		ret = -EACCES;
+	} else if (!test_bit(id, vi->id_registered)) {
+		ret = -EIO;
+	} else {
+		__clear_bit(id, vi->id_registered);
+		vi->id_refcnt--;
+		ret = 0;
+	}
+	mutex_unlock(&vi->mutex);
+
+	return ret;
+}
+
+static int vmeta_lock_user_id(struct vmeta_user *vu, struct vmeta_lock *lock)
+	__releases(vi->mutex) __acquires(vi->mutex)
+{
+	struct vmeta_instance *vi = vu->vi;
+	int ret;
+
+	if (lock->user_id >= MAX_VMETA_INSTANCE)
+		return -EINVAL;
+
+	if (!test_bit(lock->user_id, vi->id_used)) {
+		ret = -EACCES;
+	} else do {
+		if (vi->id_active == lock->user_id) {
+			ret = -EDEADLOCK;
+			break;
+		} else if (vi->id_active == MAX_VMETA_INSTANCE) {
+			vi->id_active = lock->user_id;
+			if (vi->id_lock == VMETA_LOCK_FORCE_INIT)
+				ret = -EUCLEAN;
+			else
+				ret = 0;
+			vi->id_lock = VMETA_LOCK_ON;
+			break;
+		} else {
+			mutex_unlock(&vi->mutex);
+			ret = wait_event_interruptible_timeout(vi->id_wait,
+					vi->id_active == MAX_VMETA_INSTANCE,
+					msecs_to_jiffies(lock->timeout));
+			mutex_lock(&vi->mutex);
+			if (ret == -ERESTARTSYS)
+				break;
+			if (ret == 0) {
+				ret = -ETIME;
+				break;
+			}
+			lock->timeout = 0;
+		}
+	} while (1);
+
+	return ret;
+}
+
+static int vmeta_unlock_user_id(struct vmeta_user *vu, unsigned id)
+{
+	struct vmeta_instance *vi = vu->vi;
+	int ret = 0;
+
+	if (id >= MAX_VMETA_INSTANCE)
+		return -EINVAL;
+
+	if (!test_bit(id, vi->id_used)) {
+		ret = -EACCES;
+	} else if (vi->id_active == id) {
+		vi->id_active = MAX_VMETA_INSTANCE;
+		vi->id_lock = VMETA_LOCK_OFF;
+		wake_up_interruptible(&vi->id_wait);
+	}
+
+	return ret;
+}
+
+static int vmeta_force_ini(struct vmeta_instance *vi)
+{
+	bitmap_zero(vi->id_used, MAX_VMETA_INSTANCE);
+	bitmap_zero(vi->id_registered, MAX_VMETA_INSTANCE);
+	vi->id_active = MAX_VMETA_INSTANCE;
+	vi->id_lock = VMETA_LOCK_OFF;
+	vi->id_refcnt = 0;
+	wake_up_interruptible(&vi->id_wait);
+
+	return 0;
+}
+
+union vmeta_args {
+	int sint;
+	unsigned uint;
+	struct vmeta_lock lock;
+	struct vmeta_info info;
+	struct vmeta_mmap mmap;
+	struct vmeta_dmabuf_import dmabuf_import;
+	int32_t dmabuf_release;
+};
+
+static long vmeta_unlocked_ioctl(struct file *file, unsigned int cmd,
+	unsigned long arg)
+{
+	struct vmeta_user *vu = file->private_data;
+	struct vmeta_instance *vi = vu->vi;
+	union vmeta_args args;
+	unsigned size;
+	int ret = 0;
+
+	size = _IOC_SIZE(cmd);
+	if (size > sizeof(args))
+		return -EINVAL;
+	if (_IOC_DIR(cmd) & _IOC_WRITE && size &&
+	    copy_from_user(&args, (void __user *)arg, size))
+		return -EFAULT;
+
+	switch (cmd) {
+	case VMETA_CMD_POWER_ON:
+		mutex_lock(&vi->mutex);
+		if (!vu->power_on) {
+			ret = __vmeta_power_on(vi);
+			if (ret == 0)
+				vu->power_on = true;
+		} else {
+			ret = 0;
+		}
+		mutex_unlock(&vi->mutex);
+		break;
+	case VMETA_CMD_POWER_OFF:
+		mutex_lock(&vi->mutex);
+		if (vu->power_on) {
+			ret = __vmeta_power_off(vi);
+			if (ret == 0)
+				vu->power_on = false;
+		} else {
+			ret = 0;
+		}
+		mutex_unlock(&vi->mutex);
+		break;
+	case VMETA_CMD_CLK_ON:
+		mutex_lock(&vi->mutex);
+		if (!vu->clock_on) {
+			ret = __vmeta_clk_on(vi);
+			if (ret == 0)
+				vu->clock_on = true;
+		} else {
+			ret = 0;
+		}
+		mutex_unlock(&vi->mutex);
+		break;
+	case VMETA_CMD_CLK_OFF:
+		mutex_lock(&vi->mutex);
+		if (vu->clock_on) {
+			ret = __vmeta_clk_off(vi);
+			if (ret == 0)
+				vu->clock_on = false;
+		} else {
+			ret = 0;
+		}
+		mutex_unlock(&vi->mutex);
+		break;
+	case VMETA_CMD_CLK_SWITCH:
+		ret = vmeta_clk_switch(vi, arg);
+		break;
+	case VMETA_CMD_SUSPEND_CHECK:
+		args.sint = vi->suspend;
+		ret = 0;
+		break;
+	case VMETA_CMD_SUSPEND_READY:
+		complete(&vi->suspend_complete);
+		ret = wait_event_interruptible(vi->suspend_wait, !vi->suspend);
+		break;
+	case VMETA_CMD_SUSPEND_SET:
+		vi->suspend = true;
+		break;
+	case VMETA_CMD_SUSPEND_UNSET:
+		vi->suspend = false;
+		break;
+	case VMETA_CMD_GET_USER_ID:
+		ret = vmeta_get_user_id(vu, &args.uint);
+		break;
+	case VMETA_CMD_FREE_USER_ID:
+		ret = vmeta_free_user_id(vu, arg);
+		break;
+	case VMETA_CMD_REGISTER_USER_ID:
+		ret = vmeta_register_user_id(vu, arg);
+		break;
+	case VMETA_CMD_UNREGISTER_USER_ID:
+		ret = vmeta_unregister_user_id(vu, arg);
+		break;
+	case VMETA_CMD_LOCK_USER_ID:
+		mutex_lock(&vi->mutex);
+		ret = vmeta_lock_user_id(vu, &args.lock);
+		mutex_unlock(&vi->mutex);
+		break;
+	case VMETA_CMD_UNLOCK_USER_ID:
+		mutex_lock(&vi->mutex);
+		ret = vmeta_unlock_user_id(vu, arg);
+		mutex_unlock(&vi->mutex);
+		break;
+	case VMETA_CMD_FORCE_INI:
+		mutex_lock(&vi->mutex);
+		ret = vmeta_force_ini(vi);
+		mutex_unlock(&vi->mutex);
+		if (ret == 0)
+			bitmap_zero(vu->id, MAX_VMETA_INSTANCE);
+		break;
+	case VMETA_CMD_GET_USER_NUM:
+		args.uint = vi->id_refcnt;
+		ret = 0;
+		break;
+	case VMETA_CMD_GET_INFO:
+		args.info.revision = VMETA_REVISION;
+		args.info.map[0].phys = vi->reg_phys;
+		args.info.map[0].size = vi->reg_size;
+		args.info.map[1].phys = vi->memory.dma;
+		args.info.map[1].size = vi->memory.size;
+		ret = 0;
+		break;
+	case VMETA_CMD_MAP_SW_CONTEXT:
+		args.mmap.addr = vm_mmap(vi->sw_context, 0, args.mmap.size,
+					 PROT_READ | PROT_WRITE, MAP_SHARED,
+					 0);
+		ret = IS_ERR_VALUE(args.mmap.addr) ? args.mmap.addr : 0;
+		break;
+	case VMETA_CMD_DMABUF_IMPORT:
+		ret = vmeta_dmabuf_import(vu, &args.dmabuf_import);
+		break;
+	case VMETA_CMD_DMABUF_RELEASE:
+		ret = vmeta_dmabuf_release(vu, arg);
+		break;
+	case VMETA_CMD_PM_LOCK_USER_ID:
+		mutex_lock(&vi->mutex);
+		ret = vmeta_lock_user_id(vu, &args.lock);
+		if (ret == 0 || ret == -EUCLEAN) {
+			if (vu->power_on || __vmeta_power_on(vi) == 0) {
+				if (vu->clock_on || __vmeta_clk_on(vi) == 0) {
+					vu->clock_on = true;
+					vu->power_on = true;
+				} else {
+					__vmeta_power_off(vi);
+					vu->power_on = false;
+				}
+			}
+		}
+		mutex_unlock(&vi->mutex);
+		break;
+	case VMETA_CMD_PM_UNLOCK_USER_ID:
+		mutex_lock(&vi->mutex);
+		ret = vmeta_unlock_user_id(vu, arg);
+		if (ret == 0) {
+			if (vu->clock_on)
+				__vmeta_clk_off(vi);
+			if (vu->power_on)
+				__vmeta_power_off(vi);
+			vu->clock_on = false;
+			vu->power_on = false;
+		}
+		mutex_unlock(&vi->mutex);
+		break;
+	default:
+		ret = -EINVAL;
+		break;
+	}
+
+	if (ret >= 0 && _IOC_DIR(cmd) & _IOC_READ &&
+           copy_to_user((void __user *)arg, &args, size))
+		ret = -EFAULT;
+
+	return ret;
+}
+
+static const struct file_operations vmeta_fops = {
+	.owner		= THIS_MODULE,
+	.write		= vmeta_write,
+	.poll		= vmeta_poll,
+	.unlocked_ioctl	= vmeta_unlocked_ioctl,
+	.mmap		= vmeta_mmap,
+	.open		= vmeta_open,
+	.release	= vmeta_release,
+	.fasync		= vmeta_fasync,
+};
+
+static int vmeta_alloc_dma(struct vmeta_instance *vi, size_t size)
+{
+	dma_addr_t dma;
+	void *cpu;
+
+	cpu = dma_alloc_coherent(vi->dev, size, &dma, GFP_KERNEL);
+	if (!cpu)
+		return -ENOMEM;
+
+	vi->memory.cpu = cpu;
+	vi->memory.dma = dma;
+	vi->memory.size = size;
+
+	dev_dbg(vi->dev, "internal addr[%p],addr[0x%08llx] size[%zu]\n",
+		cpu, (unsigned long long)dma, size);
+
+	return 0;
+}
+
+static int vmeta_probe(struct platform_device *pdev)
+{
+	struct resource *res;
+	struct vmeta_instance *vi;
+	int ret, irq_func, irq_bus;
+
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	if (res == NULL) {
+		dev_err(&pdev->dev, "no memory resources given\n");
+		return -ENODEV;
+	}
+
+	irq_func = platform_get_irq(pdev, 0);
+	if (irq_func < 0) {
+		dev_err(&pdev->dev, "no function irq resources given\n");
+		return -ENODEV;
+	}
+
+	irq_bus = platform_get_irq(pdev, 1);
+	if (irq_bus < 0 && (irq_bus != -ENXIO && irq_bus != -EINVAL)) {
+		dev_err(&pdev->dev, "no bus error irq resources given\n");
+		return -ENODEV;
+	}
+
+	vi = devm_kzalloc(&pdev->dev, sizeof(*vi), GFP_KERNEL);
+	if (vi == NULL) {
+		dev_err(&pdev->dev, "out of memory\n");
+		return -ENOMEM;
+	}
+
+	vi->sw_context = ERR_PTR(-EINVAL);
+
+	vi->clk = devm_clk_get(&pdev->dev, "vmeta_clk");
+	if (IS_ERR(vi->clk)) {
+		ret = PTR_ERR(vi->clk);
+		dev_err(&pdev->dev, "cannot get vmeta clock: %d\n", ret);
+		goto out_free;
+	}
+
+	/* Set vmeta default clock to 500MHz */
+	clk_set_rate(vi->clk, 500000000);
+
+	if (!devm_request_mem_region(&pdev->dev, res->start, resource_size(res),
+			dev_name(&pdev->dev))) {
+		dev_err(&pdev->dev, "can't request register region %pR\n", res);
+		ret = -ENOMEM;
+		goto out_free;
+	}
+
+	platform_set_drvdata(pdev, vi);
+
+	vi->dev = &pdev->dev;
+	mutex_init(&vi->mutex);
+	vi->use = 0;
+
+	vi->misc.minor = MISC_DYNAMIC_MINOR;
+	vi->misc.name = "vmeta";
+	vi->misc.fops = &vmeta_fops;
+	vi->misc.parent = &pdev->dev;
+
+	vi->reg_phys = res->start;
+	vi->reg_size = resource_size(res);
+
+	vi->irq_bus = irq_bus;
+	vi->irq_func = irq_func;
+	init_timer(&vi->irq_poll_timer);
+	spin_lock_init(&vi->irq_lock);
+	vi->irq_flag = 0; /* interrupt is enabled to begin with */
+
+	ret = vmeta_alloc_dma(vi, VDEC_HW_CONTEXT_SIZE);
+	if (ret)
+		goto out_free;
+
+	vi->sw_context = shmem_file_setup("vmeta sw context", VDEC_OBJ_SIZE, VM_NORESERVE);
+	if (IS_ERR(vi->sw_context)) {
+		ret = PTR_ERR(vi->sw_context);
+		goto out_free;
+	}
+
+	/* init a wait queue for pm event sync */
+	init_waitqueue_head(&vi->suspend_wait);
+	init_completion(&vi->suspend_complete);
+	vi->suspend_notifier.notifier_call = vmeta_pm_event;
+	vi->suspend_notifier.priority = -5;
+
+	init_waitqueue_head(&vi->id_wait);
+	vmeta_force_ini(vi);
+
+	init_waitqueue_head(&vi->event_wait);
+
+	pm_runtime_use_autosuspend(vi->dev);
+	pm_runtime_set_autosuspend_delay(vi->dev, 100);
+	pm_runtime_enable(vi->dev);
+
+	ret = misc_register(&vi->misc);
+	if (ret)
+		goto out_runtime;
+
+	if (vi->irq_func > 0) {
+		ret = request_irq(vi->irq_func, vmeta_func_irq_handler, 0,
+				  dev_name(&pdev->dev), vi);
+		if (ret) {
+			dev_err(&pdev->dev, "can't request func irq\n");
+			goto out_func_irq;
+		}
+	} else {
+		vi->irq_poll_timer.data = (unsigned long)vi;
+		vi->irq_poll_timer.function = vmeta_irq_poll_timer_handler;
+		mod_timer(&vi->irq_poll_timer, jiffies + HZ/100);
+	}
+
+	if (vi->irq_bus > 0) {
+		ret = request_irq(vi->irq_bus, vmeta_bus_irq_handler, 0,
+				  dev_name(&pdev->dev), vi);
+		if (ret) {
+			dev_err(&pdev->dev, "can't request bus irq\n");
+			goto out_bus_irq;
+		}
+	}
+
+	/* register a pm notifier */
+	register_pm_notifier(&vi->suspend_notifier);
+
+	return 0;
+
+out_bus_irq:
+	if (vi->irq_func > 0)
+		free_irq(vi->irq_func, vi);
+	del_timer_sync(&vi->irq_poll_timer);
+out_func_irq:
+	misc_deregister(&vi->misc);
+out_runtime:
+	pm_runtime_disable(vi->dev);
+out_free:
+	if (vi->memory.size)
+		dma_free_coherent(&pdev->dev, vi->memory.size,
+				  vi->memory.cpu, vi->memory.dma);
+
+	if (!IS_ERR(vi->sw_context))
+		fput(vi->sw_context);
+
+	return ret;
+}
+
+static int vmeta_remove(struct platform_device *pdev)
+{
+	struct vmeta_instance *vi = platform_get_drvdata(pdev);
+
+	if (vi->irq_bus > 0)
+		free_irq(vi->irq_bus, vi);
+	if (vi->irq_func > 0)
+		free_irq(vi->irq_func, vi);
+
+	del_timer_sync(&vi->irq_poll_timer);
+	misc_deregister(&vi->misc);
+
+	/* unregister pm notifier */
+	unregister_pm_notifier(&vi->suspend_notifier);
+
+	if (!IS_ERR(vi->sw_context))
+		fput(vi->sw_context);
+
+	if (vi->memory.size)
+		dma_free_coherent(&pdev->dev, vi->memory.size,
+				  vi->memory.cpu, vi->memory.dma);
+
+	pm_runtime_disable(vi->dev);
+
+	return 0;
+}
+
+static struct of_device_id vmeta_of_match[] = {
+	{
+		.compatible = "marvell,vmeta",
+	},
+	{}
+};
+MODULE_DEVICE_TABLE(of, vmeta_of_match);
+
+static struct platform_driver vmeta_driver = {
+	.probe		= vmeta_probe,
+	.remove		= vmeta_remove,
+	.driver = {
+		.name	= VMETA_NAME,
+		.owner	= THIS_MODULE,
+		.of_match_table = vmeta_of_match,
+	},
+};
+
+module_platform_driver(vmeta_driver);
+
+MODULE_DESCRIPTION("UIO driver for Marvell multi-format video codec engine");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:"VMETA_NAME);
diff --git a/drivers/soc/Makefile b/drivers/soc/Makefile
index 7dc7c0d8a2c1..c99192f30679 100644
--- a/drivers/soc/Makefile
+++ b/drivers/soc/Makefile
@@ -2,6 +2,8 @@
 # Makefile for the Linux Kernel SOC specific device drivers.
 #
 
+obj-$(CONFIG_ARCH_DOVE)		+= dove/
+obj-$(CONFIG_MACH_DOVE)		+= dove/
 obj-$(CONFIG_ARCH_MEDIATEK)	+= mediatek/
 obj-$(CONFIG_ARCH_QCOM)		+= qcom/
 obj-$(CONFIG_ARCH_SUNXI)	+= sunxi/
diff --git a/drivers/soc/dove/Makefile b/drivers/soc/dove/Makefile
new file mode 100644
index 000000000000..2db8e65513a3
--- /dev/null
+++ b/drivers/soc/dove/Makefile
@@ -0,0 +1 @@
+obj-y		+= pmu.o
